;
; FOXBIT.ASM  --  Source code for FOXBIT.PLB
;
; To assemble:  TASM /mx /m3 FOXBIT
;
; Substantial modifications will need to be made if you wish to use
; any assembler other than Turbo Assembler from Borland.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

IDEAL
Public   __FoxTable

Extrn    _RetInt_:Far                        ; API routines
Extrn    _StackAvail_:Far
Extrn    _Error_:Far

Include  "API.INC"

Group    DGROUP    _BitData

Segment  _BitData  Word      Public    "DATA"

Addr      DW       ?

OneInt    DW       "I"
TwoInts   DB       "I,I",0

BitAnd    DB       "BITAND",0
BitOr     DB       "BITOR",0
BitXor    DB       "BITXOR",0
BitNot    DB       "BITNOT",0
BitNeg    DB       "BITNEG",0
BitRol    DB       "BITROL",0
BitRor    DB       "BITROR",0
BitShl    DB       "BITSHL",0
BitShr    DB       "BITSHR",0

; This is the table of FoxInfo structures.

FuncList  FoxInfo  <far ptr BitAnd, _BitAnd, 2, far ptr TwoInts>
          FoxInfo  <far ptr BitOr,  _BitOr,  2, far ptr TwoInts>
          FoxInfo  <far ptr BitXor, _BitXor, 2, far ptr TwoInts>
          FoxInfo  <far ptr BitNot, _BitNot, 1, far ptr OneInt >
          FoxInfo  <far ptr BitNeg, _BitNeg, 1, far ptr OneInt >
          FoxInfo  <far ptr BitRol, _BitRol, 2, far ptr TwoInts>
          FoxInfo  <far ptr BitRor, _BitRor, 2, far ptr TwoInts>
          FoxInfo  <far ptr BitShl, _BitShl, 2, far ptr TwoInts>
          FoxInfo  <far ptr BitShr, _BitShr, 2, far ptr TwoInts>

; __FoxTable, the cornerstone of any library.

__FoxTable         FoxTable  <0, 9, far ptr FuncList>

Ends     _BitData



Segment  _FoxBit   Word      Public    "CODE"
         Assume    CS:_FoxBit,DS:DGROUP

Proc     _BitEntry Near

         FEnter                              ; Call entry macro
         Mov       DX,[InVal.Long.HighWord]  ; Load high word of 1st param
         Mov       AX,[InVal.Long.LowWord]   ; Load low word of 1st param
         Add       BX,PBSize                 ; Point BX to next ParamBlk
         Jmp       [Addr]                    ; Do bit manipulation
Endp     _BitEntry



Proc     _BitExit  Near

         Mov       BX,11                     ; Set display width
         Call      _RetInt_                  ; Return value to FoxPro
         FLeave                              ; Call exit macro
         RetF

Endp     _BitExit



Proc     _BitAnd   Far

         Mov       [Addr],Offset _FoxBit:@@And
         Jmp       Short _BitEntry

@@And:   And       AX,[InVal.Long.LowWord]   ; Perform bitwise AND
         And       DX,[InVal.Long.HighWord]
         Jmp       Short _BitExit

Endp     _BitAnd



Proc     _BitOr    Far

         Mov       [Addr],Offset _FoxBit:@@Or
         Jmp       Short _BitEntry

@@Or:    Or        AX,[InVal.Long.LowWord]   ; Perform bitwise OR
         Or        DX,[InVal.Long.HighWord]
         Jmp       Short _BitExit

Endp     _BitOr



Proc     _BitXor   Far

         Mov       [Addr],Offset _FoxBit:@@Xor
         Jmp       Short _BitEntry

@@Xor:   Xor       AX,[InVal.Long.LowWord]   ; Perform bitwise XOR
         Xor       DX,[InVal.Long.HighWord]
         Jmp       Short _BitExit

Endp     _BitXor



Proc     _BitNot   Far

         Mov       [Addr],Offset _FoxBit:@@Not
         Jmp       Near _BitEntry

@@Not:   Not       AX                        ; Perform bitwise NOT
         Not       DX
         Jmp       Short _BitExit

Endp     _BitNot



Proc     _BitNeg   Far

         Mov       [Addr],Offset _FoxBit:@@Neg
         Jmp       Near _BitEntry

@@Neg:   Xor       BX,BX                     ; Clear BX
         Mov       CX,BX                     ; Clear CX
         Sub       BX,AX                     ; Negate DX:AX
         Sbb       CX,DX
         Mov       AX,BX                     ; Reload DX:AX
         Mov       DX,CX                     
         Jmp       Short _BitExit

Endp     _BitNeg



Proc     _BitRol   Far

         Mov       [Addr],Offset _FoxBit:@@Rol
         Jmp       Near _BitEntry

@@Rol:   Mov       CX,[InVal.Long.LowWord]   ; Get desired # of rotates

@@Top:   ROL       AX,1                      ; Move high bit to carry flag
         ROR       AX,1
         RCL       DX,1                      ; Rotate bit through high word
         RCL       AX,1                      ; Rotate bit into low word
         Loop      @@Top                     ; Do next bit

         Jmp       Near _BitExit

Endp     _BitRol



Proc     _BitRor   Far

         Mov       [Addr],Offset _FoxBit:@@Ror
         Jmp       Near _BitEntry

@@Ror:   Mov       CX,[InVal.Long.LowWord]   ; Get desired # of rotates

@@Top:   ROR       DX,1                      ; Move low bit to carry flag
         ROL       DX,1
         RCR       AX,1                      ; Rotate bit through low word
         RCR       DX,1                      ; Rotate bit into high word
         Loop      @@Top                     ; Do next bit

         Jmp       Near _BitExit

Endp     _BitRor



Proc     _BitShl   Far

         Mov       [Addr],Offset _FoxBit:@@Shl
         Jmp       Near _BitEntry

@@Shl:   Mov       CX,[InVal.Long.LowWord]   ; Get desired # of shifts

@@Top:   SHL       AX,1
         RCL       DX,1
         Loop      @@Top                     ; Do next bit

         Jmp       Near _BitExit

Endp     _BitShl



Proc     _BitShr   Far

         Mov       [Addr],Offset _FoxBit:@@Ror
         Jmp       Near _BitEntry

@@Ror:   Mov       CX,[InVal.Long.LowWord]   ; Get desired # of rotates

@@Top:   SHR       DX,1
         RCR       AX,1
         Loop      @@Top                     ; Do next bit

         Jmp       Near _BitExit

Endp     _BitShr
Ends     _FoxBit
End
